const $ = require('jquery');
require("../css/keyItemFlawControl.less");
require('./modal.js');
const {api} = require('./api.js')
const {post,getCookie,getUrlArgObjectNew,emptyBox,setTitleTxt,setDatePicker,getPickerDate} = require('./utils.js')
require('./../resource/jquery-ui/jquery-ui.min.js');
require('./../resource/jquery-ui/jquery-ui.min.css');
const iconCheck= require("./../images/icon_check.png")
const iconUnCheck = require("./../images/icon_unchecked.png")
const iconDown= require("./../images/arrow_down.png")
const iconUp = require("./../images/arrow_up.png")
const loadingImg = require("./../images/loading.gif")
const arrowLeft= require("./../images/arrow_left.png")
const arrowRight = require("./../images/arrow_right.png")
let  deptName = "", behospitalCode="", deptNameTemp = "",deptId='',deptIdTemp='', behospitalCodeTemp="", data_desc="",data_asc="";
let srcUrl = $("#contentIframe",parent.document).attr("src")
statisticsType = getUrlArgObjectNew("dateType",srcUrl)||"";
from = getUrlArgObjectNew("from",srcUrl)||""
lineType = getUrlArgObjectNew("lineType",srcUrl)||""
let startDateParam = getUrlArgObjectNew("startDateParam",srcUrl)||""
let endDateParam = getUrlArgObjectNew("endDateParam",srcUrl)||""
$(".selectDept").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
/*if(lineType){
  $("th[code="+data_desc+"]").addClass("desc");
}*/
//setTitleTxt('',from)         //导航栏面包屑
if(statisticsType == 1){
  setDatePicker($("#datepicker"),$("#datepicker2"),1)
}else if(statisticsType == 2){
  setDatePicker($("#datepicker"),$("#datepicker2"),2)
}else if(statisticsType == 3){
  setDatePicker($("#datepicker"),$("#datepicker2"),3,new Date(startDateParam),new Date(endDateParam))
}else{
  setDatePicker($("#datepicker"),$("#datepicker2"),'default')
}

if(!statisticsType){
  setDatePicker($("#datepicker"),$("#datepicker2"),'default')
}
$(".abnormalClear").click(function(){
  data_desc="";
  data_asc="";
  deptId="";
  deptIdTemp="";
  deptName="";
  deptNameTemp="";
  setDatePicker($("#datepicker"),$("#datepicker2"),"default")
  $('.selectDept ').html('全部')
  $(".deptList").css("display", "none")
  $(".selectDept").append(`<img class="arrow" src=${iconDown} alt="下拉">`);
  $("th[code]").removeClass("asc desc")
  //behospitalCode =behospitalCodeTemp= ""
  getTabData(1)
})
$(".partTitle a").click(function(){
  //初始菜单选中
  $(".menu .page",parent.document).removeClass("active").eq(0).addClass("active");
  $(".container",parent.document).addClass("console-cont");
})

//判断有无某一权限
/*function hasData(data){
  let trdObj = JSON.parse(getCookie("trdObj"))
  let lis = trdObj['YH-BLZK-ZKPF']
  if(!lis){
    return false
  }
  if(lis.indexOf(data)>-1){//有权限
    return true
  }
  return false;
}*/
function getTabData(activePage){
  const dateStatrt = getPickerDate($("#datepicker"),1)
  const dateEnd = getPickerDate($("#datepicker2"),2)
  const start = new Date(dateStatrt).getTime()
  const end = new Date(dateEnd).getTime()
  if(start > end){
    $.alerModal({"message":'开始时间不能大于结束时间~',type:"tip",time:'1000',isFather: true, fatherWrapper: $("#mainBox", parent.document)});
    return
  }
  const param = {
    current: 1,
    size: 15,
    "deptName": deptName,
    "asc":data_asc,     //升序
    "desc":data_desc,       //降序
    //"type": 0, //1-本月，2-本年,0-自定义时间（现在所有都是自定义时间，都会传开始日期和结束日期）
    "startDate":dateStatrt,
    "endDate":dateEnd
  }
  startDateParam = dateStatrt
  endDateParam = dateEnd
  post(api.keyItemFlawControl,param).then(res =>{
    if(res.data.code == '0'){
      const data = res.data.data||[];
      renderTab(data,data.hospitalId,activePage);
      renderPagination(totalPage,Number(activePage),totalNum)
      if(totalPage > 1){
        renderPagination(totalPage,Number(activePage),totalNum)
      } else{
        $('.pagination').html("")
      }
    }else{
      $.alerModal({"message":res.data.msg,type:"tip",time:'1000',isFather: true, fatherWrapper: $("#mainBox", parent.document)});
    }
  }).catch((e) =>{

  })
}

getTabData(1)

$(".filter").on("click", function(e){
  deptName = deptNameTemp;
  behospitalCode = behospitalCodeTemp;
  getTabData(1)
})
function renderTab(data,hisId,activePage){
  let str = ``
  for(let i = 0; i < data.length; i++){
    const item = data[i]
    str += `
            <tr  data-index=${i}>
                <td  class="textCenter">${(activePage-1)*15 + i+1}</td>
                <td >${item.deptName || "-"}</td>
                <td class="goHomeDetail" dept-id="${item.deptId || ""}" dept-name="${item.deptName || ""}" data-id="${item.consultationEntryId || ""}" data-name="${item.consultationEntryName || ""}">${item.consultationNum+'' || "-"}</td>
                <td >${item.consultationPercentStr || "-"}</td>
                <td class="goHomeDetail" dept-id="${item.deptId || ""}" dept-name="${item.deptName || ""}" data-id="${item.operationNameEntryId || ""}" data-name="${item.operationNameEntryName || ""}">${item.operationNameNum+'' || "-"}</td>
                <td >${item.operationNamePercentStr+'' || "-"}</td>
                <td class="goHomeDetail" dept-id="${item.deptId || ""}" dept-name="${item.deptName || ""}" data-id="${item.operation15MinuteEntryId || ""}" data-name="${item.operation15MinuteEntryName || ""}">${item.operation15MinuteNum+'' || "-"}</td>
                <td >${item.operation15MinutePercentStr+'' || "-"}</td>
                <td class="goHomeDetail" dept-id="${item.deptId || ""}" dept-name="${item.deptName || ""}" data-id="${item.operationTimeEntryId || ""}" data-name="${item.operationTimeEntryName || ""}">${item.operationTimeNum+'' || "-"}</td>
                <td >${item.operationTimePercentStr+'' || "-"}</td>
                <td class="goHomeDetail" dept-id="${item.deptId || ""}" dept-name="${item.deptName || ""}" data-id="${item.crisisEntryId || ""}" data-name="${item.crisisEntryName || ""}">${item.crisisNum+'' || "-"}</td>
                <td >${item.crisisPercentStr+'' || "-"}</td>
                <td class="goHomeDetail" dept-id="${item.deptId || ""}" dept-name="${item.deptName || ""}" data-id="${item.stageSummaryEntryId || ""}" data-name="${item.stageSummaryEntryName || ""}">${item.stageSummaryNum+'' || "-"}</td>
                <td >${item.stageSummaryPercentStr+'' || "-"}</td>
            </tr>
        `
  }
  $('.key-list tbody').html(str?str:emptyBox())
  /*bindScoreDetail(hisId)*/
  $(".goHomeDetail").click(function(){
    let casesName = $(this).attr("data-name");
    let casesId = $(this).attr("data-id");
    let name=$(this).attr("dept-name");
    name=name==="全院"?"全部":name;
    let id=$(this).attr("dept-id");
    $(parent.document).find("#contentIframe").attr("src","itemDefectDetail.html?from=3&deptName="+name+"&deptId="+id+"&casesEntryId="+casesId+"&defectName="+casesName+"&startDate="+startDateParam+"&endDate="+endDateParam)
  })
}

$('.selectDept').on("click", function(e){
  e.stopPropagation()
  $(".selectLevel .arrow").attr("src",iconDown)
  const showList =  $(".deptList ").css("display")
  if(showList == "none" ||!showList){
    $(".deptList ").css("display","block")
    $(".selectDept .arrow").attr("src",iconUp)
  }else{
    $(".deptList ").css("display", "none")
    $(".selectDept .arrow").attr("src",iconDown)
  }
})

//获取科室列表
getDeptList()
function getDeptList(){
  post(api.getDeptList,{inputStr:""}).then(res =>{
    if(res.data.code == '0'){
      const  deptList = res.data.data
      rendeDeptList(deptList)
    }else{}
  }).catch((e) =>{

  })
}
function rendeDeptList(deptList){
  let str = `<li class="deptItem ellipsis" data-id=" " data-name="全部">全部</li>`;
  for(let i = 0; i < deptList.length; i++){
    str += `<li class="deptItem ellipsis" title=${deptList[i].deptName} data-id=${deptList[i].deptId} data-name=${deptList[i].deptName}> ${deptList[i].deptName}</li>`
  }
  $('.deptList').html(str)
  bindDeptSelect()
}
//科室选择
function bindDeptSelect(){
  $('.deptItem').on("click",function(){
    const deptItemName = $(this).attr("data-name")
    const deptItemId = $(this).attr("data-id")
    deptIdTemp =deptItemId;
    deptNameTemp=deptItemName==="全部"?"":deptItemName;
    if(deptItemName.length > 10){
      $('.selectDept').html(deptItemName.substring(0,8)+'...')
    }else{
      $('.selectDept').html(deptItemName)
    }
    $('.selectDept ').attr('title',deptItemName)
    $(".selectDept").append(`<img class="arrow" src=${iconDown} alt="下拉">`)
    $(".deptList").css("display", "none")
    $('.selectDept').removeClass('unSelect')
  })
}
function loading(){
  const str = `
    <div class="loadingBox">
            <div class="mask"></div>
            <img class="loadingImg" src=${loadingImg}  alt="loading" />
        </div>
    `
  $("#mainBox", parent.document).append(str)
}
function hideLoading(){
  $("#mainBox .loadingBox", parent.document).remove()
}
$(document).on("click", function(){
  $(".deptList").css("display", "none");
  $(".selectDept .arrow").attr("src",iconDown)
})
$("th[code]").on("click",function(e){
  const code=$(this).attr("code");
  if(data_asc==code){
    data_desc=code;
    data_asc="";
    $("th[code]").removeClass("asc desc");
    $(this).addClass("desc");
  }else{
    data_desc="";
    data_asc=code;
    $("th[code]").removeClass("asc desc");
    $(this).addClass("asc");
  }
  getTabData(1);
});


//分页渲染
function renderPagination(totalPage,activePage,totalNum){
  let str = `<span class="totalSum">共${totalPage}页/${totalNum}条数据</span><span class="prePage"><img class="arrowPage" src=${arrowLeft} /></span>`
  if(totalPage <= 6){
    for(let i = 1; i <= totalPage; i++){

      str += `<span class="pageNum ${'page'+i}" data-page=${i}>${i}</span>`
    }
  }else{
    if(activePage <= 3){ //选中页数小于4
      for(let i = 1; i <= 4; i++){
        str += `<span class="pageNum ${'page'+i}" data-page=${i}>${i}</span>`
      }
      str += `<span class="more" >...</span>`
      str += `<span class="pageNum ${'page'+totalPage}" data-page=${totalPage}>${totalPage}</span>`

    } else if(activePage > totalPage -3){
      str += `<span class="pageNum page1" data-page=1>1</span>`
      str += `<span class="more" >...</span>`
      str += `<span class="pageNum ${'page'+(totalPage-3)}" data-page=${totalPage -3}>${totalPage -3}</span>`
      str += `<span class="pageNum ${'page'+(totalPage-2)}" data-page=${totalPage -2}>${totalPage -2}</span>`
      str += `<span class="pageNum ${'page'+(totalPage-1)}" data-page=${totalPage -1}>${totalPage -1}</span>`
      str += `<span class="pageNum ${'page'+totalPage}" data-page=${totalPage}>${totalPage}</span>`
    } else {
      str += `<span class="pageNum page1" data-page=1>1</span>`
      str += `<span class="more" >...</span>`
      str += `<span class="pageNum ${'page'+(activePage -1)}" data-page=${activePage -1}>${activePage -1}</span>`
      str += `<span class="pageNum ${'page'+activePage}" data-page=${activePage}>${activePage}</span>`
      str += `<span class="pageNum ${'page'+(activePage +1)}" data-page=${activePage +1}>${activePage +1}</span>`
      str += `<span class="more" >...</span>`
      str += `<span class="pageNum ${'page'+totalPage}" data-page=${totalPage}>${totalPage}</span>`
    }

  }
  str += `<span class="nextPage"><img class="arrowPage" src=${arrowRight} /></span>`
  $('.pagination').html(str)
  $('.page' + activePage).addClass('activePage')
  $(".pageNum").on("click", function(e){
    const activePageNow = Number($(this).attr('data-page'))
    getTabData(activePageNow)
    // renderPagination(totalPage,activePageNow,totalNum)
  })
  $(".prePage").on("click", function(e){
    let activePageNow = Number($(".activePage").attr('data-page'))
    if(activePageNow > 1){
      activePageNow--
      getTabData(activePageNow)
      // renderPagination(totalPage,activePageNow,totalNum)
    }
  })
  $(".nextPage").on("click", function(e){
    let activePageNow = Number($(".activePage").attr('data-page'))
    if(activePageNow < totalPage){
      activePageNow++
      getTabData(activePageNow)
      // renderPagination(totalPage,activePageNow,totalNum)
    }
  })

}

$(function() {
  const  iconCalenBlue= require("./../images/icon_calen_blue.png")
  const  iconCalenGrey= require("./../images/icon_calen_grey.png")
  $('.datapickerBox').append(`<img class="iconCalen" src=${iconCalenGrey} />`)
  $('.iconCalen').on("mouseenter", function(e){
    $(this).attr("src", iconCalenBlue)
  })
  $('.iconCalen').on("mouseleave", function(e){
    $(this).attr("src", iconCalenGrey)
  })
  $('.iconCalen').on("click", function(e){
    $(this).parent().find("input").focus()
  })
});